diff -ruN ../nakedmudv2.2/src/account_handler.c src/account_handler.c
--- ../nakedmudv2.2/src/account_handler.c	Thu May 12 17:22:38 2005
+++ src/account_handler.c	Fri May 27 01:30:58 2005
@@ -103,7 +103,8 @@
     // check for new account
     if ( (acct = load_account(arg)) == NULL) {
       // check for lockdown
-      if(mudsettingGetInt("lockdown") > 0) {
+      if(*mudsettingGetString("lockdown") &&
+	 !is_keyword(mudsettingGetString("lockdown"), DFLT_USER_GROUP, FALSE)) {
 	text_to_socket(sock, "Sorry, creating new accounts is not allowed at the moment.\r\n");
 	close_socket(sock, FALSE);
 	return;
@@ -229,8 +230,9 @@
       charSetSocket(ch, sock);
 
       // make sure the mud isn't locked to this person
-      if(charGetLevel(ch) < mudsettingGetInt("lockdown")) {
-	text_to_socket(sock, "Sorry, the mud is currently locked down to anyone of your level and below.\r\n");
+      if(*mudsettingGetString("lockdown") &&
+	 !bitIsSet(charGetUserGroups(ch), mudsettingGetString("lockdown"))) {
+	send_to_char(ch, "You are currently locked out of the mud.\r\n");
 	deleteChar(ch);
 	socketSetChar(sock, NULL);
 	return;
@@ -302,7 +304,8 @@
 
   case 'N':
     // make a new character
-    if(mudsettingGetBool("lockdown") > 0) {
+    if(*mudsettingGetString("lockdown") &&
+       !is_keyword(mudsettingGetString("lockdown"), DFLT_USER_GROUP, FALSE)) {
       text_to_buffer(sock, "The MUD is currently locked to new players.\r\n");
       return;
     }
diff -ruN ../nakedmudv2.2/src/action.c src/action.c
--- ../nakedmudv2.2/src/action.c	Thu May 12 17:08:52 2005
+++ src/action.c	Fri May 27 01:30:58 2005
@@ -123,7 +123,7 @@
 
   // add in our example delayed action
   add_cmd("dsay", NULL, cmd_dsay, 0, POS_SITTING, POS_FLYING, 
-	  LEVEL_ADMIN, TRUE, FALSE);
+	  "admin", TRUE, FALSE);
 
   // make sure the character does not continue actions after being extracted
   add_extract_mob_func(stop_all_actions);
diff -ruN ../nakedmudv2.2/src/alias/alias.c src/alias/alias.c
--- ../nakedmudv2.2/src/alias/alias.c	Thu May 12 17:08:51 2005
+++ src/alias/alias.c	Fri May 27 01:30:57 2005
@@ -123,7 +123,7 @@
 
   // allow people to view their aliases
   add_cmd("alias", NULL, cmd_alias, 0, POS_UNCONCIOUS, POS_FLYING, 
-	  LEVEL_PLAYER, FALSE, TRUE);
+	  "player", FALSE, TRUE);
 }
 
 
diff -ruN ../nakedmudv2.2/src/bitvector.c src/bitvector.c
--- ../nakedmudv2.2/src/bitvector.c	Thu May 12 17:08:51 2005
+++ src/bitvector.c	Fri May 27 01:58:56 2005
@@ -85,6 +85,13 @@
 
   bitvectorCreate("obj_bits");
   bitvectorAddBit("obj_bits", "notake");
+
+  bitvectorCreate("user_groups");
+  bitvectorAddBit("user_groups", "admin");
+  bitvectorAddBit("user_groups", "scripter");
+  bitvectorAddBit("user_groups", "builder");
+  bitvectorAddBit("user_groups", "player");
+  bitvectorAddBit("user_groups", "playtester");
 }
 
 void bitvectorAddBit(const char *name, const char *bit) {
@@ -191,6 +198,12 @@
     SET_BIT(v->bits[val/8], (1 << (val % 8)));
   }
   free(bits);
+}
+
+void bitClear(BITVECTOR *v) {
+  int i;
+  for(i = 1; i <= hashSize(v->data->bitmap); i++)
+    REMOVE_BIT(v->bits[i/8], (1 << (i % 8)));
 }
 
 void bitRemove(BITVECTOR *v, const char *name) {
diff -ruN ../nakedmudv2.2/src/bitvector.h src/bitvector.h
--- ../nakedmudv2.2/src/bitvector.h	Thu May 12 17:08:51 2005
+++ src/bitvector.h	Fri May 27 01:58:56 2005
@@ -90,6 +90,10 @@
 void bitRemove(BITVECTOR *v, const char *name);
 
 //
+// sets all of the bits on the vector to off
+void bitClear(BITVECTOR *v);
+
+//
 // toggle the specified bits on or off... whichever one they are not, currently
 void bitToggle(BITVECTOR *v, const char *name);
 
diff -ruN ../nakedmudv2.2/src/body.c src/body.c
--- ../nakedmudv2.2/src/body.c	Thu May 12 17:08:51 2005
+++ src/body.c	Fri May 27 01:30:58 2005
@@ -480,7 +480,7 @@
   BODYPART *part = NULL;
 
   ITERATE_LIST(part, part_i)
-    if(part->equipment)
+    if(part->equipment && !listIn(equipment, part->equipment))
       listPut(equipment, part->equipment);
   deleteListIterator(part_i);
   return equipment;
@@ -492,7 +492,7 @@
   BODYPART *part = NULL;
 
   ITERATE_LIST(part, part_i) {
-    if(part->equipment) {
+    if(part->equipment && !listIn(equipment, part->equipment)) {
       listPut(equipment, part->equipment);
       part->equipment = NULL;
     }
diff -ruN ../nakedmudv2.2/src/char_gen.c src/char_gen.c
--- ../nakedmudv2.2/src/char_gen.c	Thu May 12 17:08:51 2005
+++ src/char_gen.c	Fri May 27 01:30:58 2005
@@ -145,9 +145,10 @@
     mudsettingSetInt("puid", next_char_uid);
     charSetUID(socketGetChar(sock), next_char_uid);
     
-    // if it's the first player, set him as the highest level 
+    // if it's the first player, give him all priviledges
     if(charGetUID(socketGetChar(sock)) == 1)
-      charSetLevel(socketGetChar(sock), MAX_LEVEL);
+      bitSet(charGetUserGroups(socketGetChar(sock)),
+	     "admin, builder, scripter, player, playtester");
 
     // add the character to the game 
     char_to_game(socketGetChar(sock));
diff -ruN ../nakedmudv2.2/src/character.c src/character.c
--- ../nakedmudv2.2/src/character.c	Thu May 12 17:08:51 2005
+++ src/character.c	Fri May 27 01:30:58 2005
@@ -91,7 +91,6 @@
 struct char_data {
   // data for PCs only
   room_vnum              loadroom;
-  int                    imm_invis;
 
   // shared data for PCs and NPCs
   int                    uid;
@@ -105,13 +104,13 @@
   OBJ_DATA             * furniture;
   BUFFER               * desc;
   char                 * name;
-  int                    level;
   int                    sex;
   int                    position;
 
   LIST                 * inventory;
   HASHTABLE            * auxiliary_data;
   BITVECTOR            * prfs;
+  BITVECTOR            * user_groups;
 
   // data for NPCs only
   dialog_vnum            dialog;
@@ -126,8 +125,6 @@
 CHAR_DATA *newChar() {
   CHAR_DATA *ch   = calloc(1, sizeof(CHAR_DATA));
 
-  ch->imm_invis     = 0;
-
   ch->loadroom      = NOWHERE;
   ch->uid           = NOBODY;
 
@@ -138,7 +135,6 @@
   ch->socket        = NULL;
   ch->desc          = newBuffer(1);
   ch->name          = strdup("");
-  ch->level         = LEVEL_PLAYER;
   ch->sex           = SEX_NEUTRAL;
   ch->position      = POS_STANDING;
   ch->inventory     = newList();
@@ -150,6 +146,8 @@
   ch->dialog        = NOTHING;
   ch->vnum          = NOBODY;
   ch->prfs          = bitvectorInstanceOf("char_prfs");
+  ch->user_groups   = bitvectorInstanceOf("user_groups");
+  bitSet(ch->user_groups, DFLT_USER_GROUP);
 
   ch->auxiliary_data = newAuxiliaryData(AUXILIARY_TYPE_CHAR);
 
@@ -231,10 +229,6 @@
   return ch->multi_name;
 }
 
-int          charGetLevel     ( CHAR_DATA *ch) {
-  return ch->level;
-};
-
 int         charGetSex        ( CHAR_DATA *ch) {
   return ch->sex;
 };
@@ -268,14 +262,14 @@
   return ch->furniture;
 }
 
-int charGetImmInvis(CHAR_DATA *ch) {
-  return ch->imm_invis;
-}
-
 BITVECTOR *charGetPrfs(CHAR_DATA *ch) {
   return ch->prfs;
 }
 
+BITVECTOR *charGetUserGroups(CHAR_DATA *ch) {
+  return ch->user_groups;
+}
+
 void         charSetSocket    ( CHAR_DATA *ch, SOCKET_DATA *socket) {
   ch->socket = socket;
 };
@@ -289,10 +283,6 @@
   ch->name = strdup(name ? name : "");
 };
 
-void         charSetLevel     ( CHAR_DATA *ch, int level) {
-  ch->level = level;
-};
-
 void         charSetSex       ( CHAR_DATA *ch, int sex) {
   ch->sex = sex;
 };
@@ -335,9 +325,6 @@
   ch->furniture = furniture;
 }
 
-void charSetImmInvis(CHAR_DATA *ch, int level) {
-  ch->imm_invis = level;
-}
 
 
 //*****************************************************************************
@@ -366,6 +353,7 @@
   if(mob->multi_name)  free(mob->multi_name);
   if(mob->keywords)    free(mob->keywords);
   if(mob->prfs)        deleteBitvector(mob->prfs);
+  if(mob->user_groups) deleteBitvector(mob->user_groups);
   deleteAuxiliaryData(mob->auxiliary_data);
 
   free(mob);
@@ -382,14 +370,17 @@
   charSetDesc(mob,         read_string(set, "desc"));
   charSetMultiRdesc(mob,   read_string(set, "multirdesc"));
   charSetMultiName(mob,    read_string(set, "multiname"));
-  charSetLevel(mob,        read_int   (set, "level"));
   charSetSex(mob,          read_int   (set, "sex"));
   charSetRace(mob,         read_string(set, "race"));
   bitSet(mob->prfs,        read_string(set, "prfs"));
+  bitSet(mob->user_groups, read_string(set, "user_groups"));
+
+  // make sure we always have the default group assigned
+  if(!*bitvectorGetBits(mob->user_groups))
+    bitSet(mob->user_groups, DFLT_USER_GROUP);
 
   // read in PC data if it exists
   if(storage_contains(set, "uid")) {
-    charSetImmInvis(mob,   read_int   (set, "imm_invis"));
     charSetUID(mob,        read_int   (set, "uid"));
     charSetLoadroom(mob,   read_int   (set, "loadroom"));
     charSetPos(mob,        read_int   (set, "position"));
@@ -424,14 +415,13 @@
   store_string(set, "desc",       bufferString(mob->desc));
   store_string(set, "multirdesc", mob->multi_rdesc);
   store_string(set, "multiname",  mob->multi_name);
-  store_int   (set, "level",      mob->level);
   store_int   (set, "sex",        mob->sex);
   store_string(set, "race",       mob->race);
   store_string(set, "prfs",       bitvectorGetBits(mob->prfs));
+  store_string(set, "user_groups",bitvectorGetBits(mob->user_groups));
 
   // PC-only data
   if(!charIsNPC(mob)) {
-    store_int   (set, "imm_invis",  mob->imm_invis);
     store_int   (set, "position",   mob->position);
     store_int   (set, "uid",        mob->uid);
     store_int   (set, "loadroom",   roomGetVnum(charGetRoom(mob)));
@@ -455,12 +445,11 @@
   charSetRdesc      (to, charGetRdesc(from));
   charSetMultiRdesc (to, charGetMultiRdesc(from));
   charSetMultiName  (to, charGetMultiName(from));
-  charSetLevel      (to, charGetLevel(from));
   charSetSex        (to, charGetSex(from));
   charSetPos        (to, charGetPos(from));
   charSetRace       (to, charGetRace(from));
   charSetBody       (to, bodyCopy(charGetBody(from)));
-  charSetImmInvis   (to, charGetImmInvis(from));
+  bitvectorCopyTo   (from->prfs, to->prfs);
   bitvectorCopyTo   (from->prfs, to->prfs);
 
   auxiliaryDataCopyTo(from->auxiliary_data, to->auxiliary_data);
diff -ruN ../nakedmudv2.2/src/character.h src/character.h
--- ../nakedmudv2.2/src/character.h	Thu May 12 17:08:51 2005
+++ src/character.h	Fri May 27 01:30:58 2005
@@ -15,10 +15,23 @@
 //*****************************************************************************
 
 
+
+//*****************************************************************************
+// character defines
+//*****************************************************************************
+
+// the group a character belongs to by default
+#define DFLT_USER_GROUP        "player"
+
+
+
+//*****************************************************************************
+// character functions
+//*****************************************************************************
+
 //
 // the difference between newChar and newMobile is that newMobile
 // assigned a new UID whereas newChar does not.
-//
 CHAR_DATA   *newChar          (void);
 CHAR_DATA    *newMobile       (void);
 void         deleteChar       (CHAR_DATA *mob);
@@ -37,10 +50,9 @@
 
 
 
+
 //*****************************************************************************
-//
 // utility functions
-//
 //*****************************************************************************
 
 /* buffers the output        */
@@ -51,14 +63,13 @@
 __attribute__ ((format (printf, 2, 3)));
 void send_around_char(CHAR_DATA *ch, bool hide_nosee, const char *format, ...) 
 __attribute__ ((format (printf, 3, 4)));
-void send_to_level(int level, const char *format, ...) 
+void send_to_groups(const char *groups, const char *Format, ...)
 __attribute__ ((format (printf, 2, 3)));
 
 
+
 //*****************************************************************************
-//
 // set and get functions
-//
 //*****************************************************************************
 SOCKET_DATA *charGetSocket    ( CHAR_DATA *ch);
 ROOM_DATA   *charGetRoom      ( CHAR_DATA *ch);
@@ -67,7 +78,6 @@
 const char  *charGetRdesc     ( CHAR_DATA *ch);
 const char  *charGetMultiRdesc( CHAR_DATA *ch);
 const char  *charGetMultiName ( CHAR_DATA *ch);
-int          charGetLevel     ( CHAR_DATA *ch);
 int          charGetSex       ( CHAR_DATA *ch);
 // for editing with the text editor
 BUFFER      *charGetDescBuffer( CHAR_DATA *ch);
@@ -79,14 +89,13 @@
 int          charGetPos       ( CHAR_DATA *ch);
 int          charGetUID       ( const CHAR_DATA *ch);
 void        *charGetAuxiliaryData(const CHAR_DATA *ch, const char *name);
-int          charGetImmInvis  ( CHAR_DATA *ch);
 BITVECTOR   *charGetPrfs      ( CHAR_DATA *ch);
+BITVECTOR   *charGetUserGroups( CHAR_DATA *ch);
 
 
 void         charSetSocket    ( CHAR_DATA *ch, SOCKET_DATA *socket);
 void         charSetRoom      ( CHAR_DATA *ch, ROOM_DATA *room);
 void         charSetName      ( CHAR_DATA *ch, const char *name);
-void         charSetLevel     ( CHAR_DATA *ch, int level);
 void         charSetSex       ( CHAR_DATA *ch, int sex);
 void         charSetDesc      ( CHAR_DATA *ch, const char *desc);
 void         charSetRdesc     ( CHAR_DATA *ch, const char *rdesc);
@@ -98,14 +107,11 @@
 void         charSetLoadroom  ( CHAR_DATA *ch, room_vnum loadroom);
 void         charSetFurniture ( CHAR_DATA *ch, OBJ_DATA *furniture);
 void         charSetPos       ( CHAR_DATA *ch, int pos);
-void         charSetImmInvis  ( CHAR_DATA *ch, int level);
 
 
 
 //*****************************************************************************
-//
 // mob-specific functions
-//
 //*****************************************************************************
 mob_vnum     charGetVnum       (CHAR_DATA *ch);
 dialog_vnum  charGetDialog     (CHAR_DATA *ch);
@@ -118,9 +124,7 @@
 
 
 //*****************************************************************************
-//
 // Sexes
-//
 //*****************************************************************************
 #define SEX_NONE                (-1)
 #define SEX_MALE                  0
@@ -134,9 +138,7 @@
 
 
 //*****************************************************************************
-//
 // Positions
-//
 //*****************************************************************************
 #define POS_NONE                (-1)
 #define POS_UNCONCIOUS            0
diff -ruN ../nakedmudv2.2/src/cmd_admin.c src/cmd_admin.c
--- ../nakedmudv2.2/src/cmd_admin.c	Thu May 12 17:08:51 2005
+++ src/cmd_admin.c	Fri May 27 01:30:58 2005
@@ -26,48 +26,39 @@
 //*****************************************************************************
 
 //
-// Locks the game for anyone at or below the lockdown level. No argument tells
-// us the current lockdown level. Suggested by Rhaelar
+// Locks the game for anyone not a member of one of the user groups we specify.
 COMMAND(cmd_lockdown) {
-  int lockdown = 0;
-
-  // we're trying to view the current lockdown level
+  // check the current lockdown status
   if(!*arg) {
-    lockdown = mudsettingGetInt("lockdown");
-    // no lockdown in place
-    if(lockdown == 0)
-      send_to_char(ch, "The mud currently is not locked to anyone.\r\n");
-    else if(lockdown == 1)
-      send_to_char(ch, "The mud is locked down to new players.\r\n");
-    else
-      send_to_char(ch, "The mud is locked to anyone below level %d.\r\n",
-		   lockdown);
+    if(!*mudsettingGetString("lockdown"))
+      send_to_char(ch, "Lockdown is currently turned off.\r\n");
+    else {
+      send_to_char(ch, "Current lockdown is to members not of: %s\r\n",
+		   mudsettingGetString("lockdown"));
+      send_to_char(ch, "To turn off lockdown, use {clockdown off{n\r\n");
+    }
   }
 
-  // make sure we've got a level number
-  else if(!isdigit(*arg))
-    send_to_char(ch, "Which level would you like to set the lockdown to?\r\n");
+  // turn lockdown off
+  else if(!strcasecmp(arg, "off")) {
+    send_to_char(ch, "Lockdown disabled.\r\n");
+    mudsettingSetString("lockdown", "");
+  }
 
-  // make sure we don't lock ourself out
-  else if( (lockdown = atoi(arg)) > charGetLevel(ch))
-    send_to_char(ch, "You cannot lock out people below that level!\r\n");
+  // make sure we're not locking ourself out
+  else if(!bitIsSet(charGetUserGroups(ch), arg))
+    send_to_char(ch, "You cannot lock yourself out!\r\n");
 
-  // do the lockdown
+  // lock out anyone not in the groups we specify
   else {
-    mudsettingSetInt("lockdown", lockdown);
-    if(lockdown == 0)
-      send_to_char(ch, "Lockdown removed.\r\n");
-    else if(lockdown == 1)
-      send_to_char(ch, "New players are locked down.\r\n");
-    else
-      send_to_char(ch, "Everyone below level %d is locked down.\r\n", lockdown);
+    send_to_char(ch, "MUD locked down to everyone not in groups: %s\r\n", arg);
+    mudsettingSetString("lockdown", arg);
 
-    // kick out anyone that is at or below our lockdown threshold.
+    // kick out everyone who we've just locked out
     LIST_ITERATOR *ch_i = newListIterator(mobile_list);
     ITERATE_LIST(ch, ch_i) {
-      if(!charIsNPC(ch) && charGetLevel(ch) < lockdown) {
-	send_to_char(ch, "The mud has just been locked down to anyone at or "
-		     "below your level.\r\n");
+      if(!charIsNPC(ch) && !bitIsSet(charGetUserGroups(ch), arg)) {
+	send_to_char(ch, "The mud has just been locked down to you.\r\n");
 	save_player(ch);
 
 	// and close the socket if we have one
@@ -280,59 +271,4 @@
 
   if (!found)
     text_to_char(ch, "Noone is currently linkdead.\n\r");
-}
-
-
-//
-// List all of the non-player commands the character has access to
-COMMAND(cmd_wizhelp) {
-  show_commands(ch, LEVEL_BUILDER, charGetLevel(ch));
-}
-
-
-//
-// Turn on/off immortal invisibility
-COMMAND(cmd_invis) {
-  int level = charGetLevel(ch); // default to our level
-  if(arg && *arg && isdigit(*arg))
-    level = atoi(arg);
-
-  // make sure we're not trying to go invisible at a level higher than us
-  if(level > charGetLevel(ch)) {
-    send_to_char(ch, "You cannot go invisibile to a level higher than yours.\r\n");
-    return;
-  }
-
-  // see if we're trying to go visible
-  if(level == 0 && charGetImmInvis(ch) > 0) {
-    send_to_char(ch, "Invisibility turned off.\r\n");
-    charSetImmInvis(ch, 0);
-    message(ch, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
-	    "$n slowly fades into existence.");    
-  }
-  // or invisible
-  else if(level > 0) {
-    message(ch, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
-	    "$n slowly fades out of existence.");
-    charSetImmInvis(ch, level);
-    send_to_char(ch, "You are now invisible to anyone below level %d.\r\n",
-		 level);
-  }
-  // we tried to go visible, but we already are visible
-  else
-    send_to_char(ch, "But you're already visible!\r\n");
-}
-
-
-//
-// turn off immortal invisibility
-COMMAND(cmd_visible) {
-  if(charGetImmInvis(ch) == 0)
-    send_to_char(ch, "But you're already visible!\r\n");
-  else {
-    charSetImmInvis(ch, 0);
-    send_to_char(ch, "You fade into existence.\r\n");
-    message(ch, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
-	    "$n slowly fades into existence.");
-  }
 }
diff -ruN ../nakedmudv2.2/src/cmd_builder.c src/cmd_builder.c
--- ../nakedmudv2.2/src/cmd_builder.c	Thu May 12 17:08:51 2005
+++ src/cmd_builder.c	Fri May 27 01:30:58 2005
@@ -215,6 +215,10 @@
 		    ch, NULL, charGetRoom(ch), NULL, NULL, 0);
       }
     }
+
+    // type not found
+    else 
+      send_to_char(ch, "What type of thing did you want to load?\r\n");
   }
 }
 
@@ -225,7 +229,6 @@
 //   usage: purge <target>
 //
 COMMAND(cmd_purge) {
-
   // purge everything
   if(!arg || !*arg) {
     LIST_ITERATOR *list_i = newListIterator(roomGetContents(charGetRoom(ch)));
@@ -246,7 +249,6 @@
     ITERATE_LIST(vict, list_i) {
       if(vict == ch || !charIsNPC(vict)) 
 	continue;
-      char_from_room(vict);
       extract_mobile(vict);
     }
     deleteListIterator(list_i);
@@ -263,11 +265,17 @@
 			 FIND_SCOPE_ROOM | FIND_SCOPE_VISIBLE,
 			 FALSE, &found_type);
 
-    // purge  characters
-    if(found_type == FOUND_CHAR) {
-      if(charGetLevel(ch) <= charGetLevel(found))
-	send_to_char(ch, "Erm, you better not try that on %s.\r\n", 
-		     HIMHER(found));
+    // make sure we found something
+    if(found == NULL)
+      send_to_char(ch, "Purge what?\r\n");
+
+    // purge characters
+    else if(found_type == FOUND_CHAR) {
+      // we can only purge him if we have all the same groups as him, and more
+      if(!charHasMoreUserGroups(ch, found))
+	send_to_char(ch, "Erm, you better not try that on %s. %s has "
+		     "just as much priviledges as you.\r\n", 
+		     HIMHER(found), HESHE(found));
       else {
 	send_to_char(ch, "You purge %s.\r\n", charGetName(found));
 	message(ch, found, NULL, NULL, FALSE, TO_NOTVICT | TO_NOTCHAR,
diff -ruN ../nakedmudv2.2/src/commands.h src/commands.h
--- ../nakedmudv2.2/src/commands.h	Thu May 12 17:08:52 2005
+++ src/commands.h	Fri May 27 01:30:58 2005
@@ -14,9 +14,6 @@
 COMMAND(cmd_copyover);
 COMMAND(cmd_shutdown);
 COMMAND(cmd_linkdead);
-COMMAND(cmd_wizhelp);
-COMMAND(cmd_invis);
-COMMAND(cmd_visible);
 COMMAND(cmd_repeat);
 COMMAND(cmd_at);
 COMMAND(cmd_lockdown);
@@ -84,6 +81,7 @@
 COMMAND(cmd_look);
 COMMAND(cmd_inventory);
 COMMAND(cmd_equipment);
+COMMAND(cmd_groupcmds);
 
 
 /* olc.c */
diff -ruN ../nakedmudv2.2/src/editor/notepad.c src/editor/notepad.c
--- ../nakedmudv2.2/src/editor/notepad.c	Thu May 12 17:08:51 2005
+++ src/editor/notepad.c	Fri May 27 01:30:57 2005
@@ -94,7 +94,7 @@
 
   // install our commands
   add_cmd("write", NULL, cmd_write, 0, POS_SITTING, POS_FLYING,
-	  LEVEL_PLAYER, FALSE, TRUE);
+	  "player", FALSE, TRUE);
   add_cmd("notepad", NULL, cmd_notepad, 0, POS_SITTING, POS_FLYING,
-	  LEVEL_PLAYER, FALSE, TRUE);
+	  "player", FALSE, TRUE);
 }
diff -ruN ../nakedmudv2.2/src/event.c src/event.c
--- ../nakedmudv2.2/src/event.c	Thu May 12 17:08:52 2005
+++ src/event.c	Fri May 27 01:30:58 2005
@@ -113,7 +113,7 @@
 
   // add our proof of concept command
   add_cmd("devent", NULL, cmd_devent, 0, POS_SLEEPING, POS_FLYING,
-	  LEVEL_ADMIN, TRUE, FALSE);
+	  "admin", TRUE, FALSE);
 
   // make sure all events involving the object/char are cancelled when
   // either is extracted from the game
diff -ruN ../nakedmudv2.2/src/extra_descs.c src/extra_descs.c
--- ../nakedmudv2.2/src/extra_descs.c	Thu May 12 17:08:52 2005
+++ src/extra_descs.c	Fri May 27 01:41:17 2005
@@ -72,14 +72,7 @@
 void edescSetCopyTo(EDESC_SET *from, EDESC_SET *to) {
   // delete all of the current entries
   deleteListWith(to->edescs, deleteEdesc);
-  to->edescs = newList();
-
-  // copy all of them over and set their parent to us
-  EDESC_DATA    *entry   = NULL;
-  LIST_ITERATOR *edesc_i = newListIterator(from->edescs);
-  ITERATE_LIST(entry, edesc_i)
-    edescSetPut(to, edescCopy(entry));
-  deleteListIterator(edesc_i);
+  to->edescs = listCopyWith(from->edescs, edescCopy);
 }
 
 
diff -ruN ../nakedmudv2.2/src/gameloop.c src/gameloop.c
--- ../nakedmudv2.2/src/gameloop.c	Thu May 12 17:15:17 2005
+++ src/gameloop.c	Fri May 27 01:33:01 2005
@@ -53,7 +53,6 @@
 #endif
 
 
-
 /* local procedures */
 void game_loop    ( int control );
 bool gameloop_end = FALSE;
@@ -120,9 +119,6 @@
   /* get the current time */
   current_time = time(NULL);
 
-  // change to the lib directory
-  //log_string("Changing to lib directory.");
-  //chdir("../lib");
 
 
   /************************************************************/
@@ -153,13 +149,9 @@
   /*        INITIALIZE OUR SETTINGS AND BASIC SYSTEMS         */
   /************************************************************/
 
-  /* initialize our mud settings, such as top character id */
-  log_string("Initializing MUD settings.");
-  init_mud_settings();
-
-  /* set up the stuff for auxiliary data */
-  log_string("Preparing auxiliary data for usage.");
-  init_auxiliaries();
+  // change to the lib directory
+  log_string("Changing to lib directory.");
+  chdir("../lib");
 
   log_string("Initializing bitvectors.");
   init_bitvectors();
@@ -167,6 +159,12 @@
   log_string("Initializing races and default bodies.");
   init_races();
 
+  log_string("Initializing MUD settings.");
+  init_mud_settings();
+
+  log_string("Preparing auxiliary data for usage.");
+  init_auxiliaries();
+
   log_string("Initializing command table.");
   init_commands();
 
@@ -200,9 +198,6 @@
   log_string("Initializing set utility.");
   init_set();
 
-  log_string("Initializing scripts.");
-  init_scripts();
-
 
   
   /**********************************************************************/
@@ -227,6 +222,19 @@
   log_string("Initializing helpfiles.");
   init_help();
 #endif
+
+
+
+  /**********************************************************************/
+  /*                   SET UP ALL OF OUR PYTHON STUFF                   */
+  /**********************************************************************/
+
+  //
+  // this HAS to be the last module initialized, to allow all the other
+  // modules to add get/setters and methods to the Python incarnations of
+  // our various datatypes.
+  log_string("Initializing scripts.");
+  init_scripts();
 
 
 
Binary files ../nakedmudv2.2/src/help/.DS_Store and src/help/.DS_Store differ
diff -ruN ../nakedmudv2.2/src/help/help.c src/help/help.c
--- ../nakedmudv2.2/src/help/help.c	Thu May 12 17:08:51 2005
+++ src/help/help.c	Fri May 27 01:30:57 2005
@@ -449,15 +449,15 @@
 
   // add all of our commands
   add_cmd("help", NULL, cmd_help, 0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_PLAYER, FALSE, FALSE);
+	  "player", FALSE, FALSE);
   add_cmd("hlink", NULL, cmd_hlink, 0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_ADMIN, FALSE, FALSE);
+	  "admin", FALSE, FALSE);
   add_cmd("hunlink", NULL, cmd_hunlink, 0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_ADMIN, FALSE, FALSE);
+	  "admin", FALSE, FALSE);
   add_cmd("hupdate", NULL, cmd_hupdate, 0, POS_SITTING, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, TRUE);
+	  "builder", FALSE, TRUE);
   add_cmd("hedit", NULL, cmd_hedit, 0, POS_SITTING, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, TRUE);
+	  "builder", FALSE, TRUE);
 
   // read in all of our helps
   STORAGE_SET       *set = storage_read(HELP_FILE);
diff -ruN ../nakedmudv2.2/src/inform.c src/inform.c
--- ../nakedmudv2.2/src/inform.c	Thu May 12 17:08:52 2005
+++ src/inform.c	Fri May 27 01:30:58 2005
@@ -58,14 +58,14 @@
   listRemove(can_see, ch);
 
   char *chars = print_list(can_see, charGetName, charGetMultiName);
-  if(*chars) send_to_char(ch, "%s %s %s %s%s.\r\n",
+  if(*chars) send_to_char(ch, "{g%s %s %s %s%s.\r\n",
 			  chars, (listSize(can_see) == 1 ? "is" : "are"),
 			  (furnitureGetType(furniture)==FURNITURE_AT?"at":"on"),
 			  objGetName(furniture),
 			  (charGetFurniture(ch) == furniture ?" with you": ""));
   // everyone was invisible to us... we should still show the furniture though
   else
-    send_to_char(ch, "%s\r\n", objGetRdesc(furniture));
+    send_to_char(ch, "{g%s\r\n", objGetRdesc(furniture));
   deleteList(can_see);
   free(chars);
 }
@@ -240,12 +240,12 @@
       continue;
     }
     
-    if(charGetLevel(ch) > LEVEL_PLAYER)
+    if(bitIsOneSet(charGetUserGroups(ch), "builder"))
       sprintf(buf, "[%d] ", roomGetVnum(to));
     else
       buf[0] = '\0';
     
-    send_to_char(ch, "  %-10s :: %s%s\r\n", 
+    send_to_char(ch, "{g  %-10s :: %s%s\r\n", 
 		 dirGetName(i),
 		 buf,
 		 (exitIsClosed(exit) ? 
@@ -270,12 +270,12 @@
        continue;
     }
 
-    if(charGetLevel(ch) > LEVEL_PLAYER)
+    if(bitIsOneSet(charGetUserGroups(ch), "builder"))
       sprintf(buf, "[%d] ", roomGetVnum(to));
     else
       buf[0] = '\0';
     
-    send_to_char(ch, "  %-10s :: %s%s\r\n", 
+    send_to_char(ch, "{g  %-10s :: %s%s\r\n", 
 		 names[i],
 		 buf,
 		 (exitIsClosed(exit) ? 
@@ -318,7 +318,7 @@
 
 
 void look_at_room(CHAR_DATA *ch, ROOM_DATA *room) {
-  if(charGetLevel(ch) > LEVEL_PLAYER)
+  if(bitIsOneSet(charGetUserGroups(ch), "builder"))
     send_to_char(ch, "{c[%d] ", roomGetVnum(room));
 
   send_to_char(ch, "{c%s\r\n", roomGetName(room));
@@ -417,7 +417,7 @@
 }
 
 
-void send_to_level(int level, const char *format, ...) {
+void send_to_groups(const char *groups, const char *format, ...) {
   static char buf[MAX_BUFFER];
   va_list args;
   va_start(args, format);
@@ -428,7 +428,7 @@
   CHAR_DATA       *ch = NULL;
 
   ITERATE_LIST(ch, ch_i) {
-    if(!charGetSocket(ch) || charGetLevel(ch) < level)
+    if(!charGetSocket(ch) || !bitIsSet(charGetUserGroups(ch), groups))
       continue;
     text_to_char(ch, buf);
   }
@@ -482,6 +482,20 @@
 
 
 //
+// lists all of the commands available to a character via some group. If the
+// character is not part of the group, s/he cannot see the commands
+COMMAND(cmd_groupcmds) {
+  if(!*arg)
+    send_to_char(ch, "Which group did you want to commands for: %s\r\n",
+		 bitvectorGetBits(charGetUserGroups(ch)));
+  else if(!bitIsOneSet(charGetUserGroups(ch), arg))
+    send_to_char(ch, "You are not a member of user group, %s.\r\n", arg);
+  else
+    show_commands(ch, arg);
+}
+
+
+//
 // cmd_look lets a character get information about a specific thing. Objects,
 // characters, extra descriptions, and just about anything else that can exist
 // in the MUD can be looked at.
@@ -592,7 +606,7 @@
   if(listSize(charGetInventory(ch)) == 0)
     send_to_char(ch, "You aren't carrying anything.\r\n");
   else {
-    send_to_char(ch, "You are carrying:\r\n");
+    send_to_char(ch, "{gYou are carrying:\r\n");
     LIST *vis_objs = find_all_objs(ch, charGetInventory(ch), "", NOTHING, TRUE);
     show_list(ch, vis_objs, objGetName, objGetMultiName, objGetVnum);
     deleteList(vis_objs);
@@ -604,7 +618,7 @@
 // show a list of all commands available to the character
 //
 COMMAND(cmd_commands) {
-  show_commands(ch, LEVEL_PLAYER, charGetLevel(ch));
+  show_commands(ch, bitvectorGetBits(charGetUserGroups(ch)));
 }
 
 
@@ -620,7 +634,7 @@
 
   bprintf(buf, 
 	  "{cPlayers Online:\r\n"
-	  "{gLevel    Race )\r\n"
+	  "{gStatus   Race )\r\n"
 	  );
 
   // build our list of people online
@@ -628,10 +642,12 @@
     socket_count++;
     if ((plr = socketGetChar(dsock)) == NULL) continue;
     playing_count++;
-    bprintf(buf, "{y%-8s %-3s  {g)  {c%-12s {b%26s\r\n", 
-	    (charGetLevel(plr) == LEVEL_PLAYER ? "player" :
-	     (charGetLevel(plr) == LEVEL_BUILDER  ? "builder" :
-	      (charGetLevel(plr) == LEVEL_SCRIPTER    ? "scripter" : "admin"))),
+    bprintf(buf, "{y%-8s %-3s  {g)  {c%-12s {b%26s\r\n",
+	    (bitIsSet(charGetUserGroups(ch), "admin") ? "admin" :
+	     (bitIsSet(charGetUserGroups(ch), "scripter") ? "scripter" :
+	      (bitIsSet(charGetUserGroups(ch), "builder") ? "builder"  :
+	       (bitIsSet(charGetUserGroups(ch), "player") ? "player" : 
+		"noone!")))),
 	    raceGetAbbrev(charGetRace(plr)),
 	    charGetName(plr), socketGetHostname(dsock));
   } deleteListIterator(sock_i);
